package nc.bs.yp.impl;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.NCLocator;
import nc.bs.servlet.service.BaseServlet;
import nc.md.model.MetaDataException;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.mmpac.pmo.pac0002.entity.PMOAggVO;
import net.sf.json.JSONObject;

/**
 * ޸Ŀ״̬
 * @author LP
 *
 */
@SuppressWarnings("restriction")
public class PomUpdateStatusImpl extends BaseServlet implements IHttpServletAdaptor {
	
	private static final String TURE = "0";
	private static final String FALSE = "1";
	private StringBuffer error = new StringBuffer();
	private IMDPersistenceQueryService qryService = NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
	private BaseDAO basedao = new BaseDAO();

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		String json = buildJson(req, resp, this.getClass().getName());
		PrintWriter out = resp.getWriter();
		
		JSONObject p_data = JSONObject.fromObject(json);//ȡ
		
		if (!checkJson(p_data)) {
			out.print(formatRSJsonData(FALSE, p_data.getString("vbillcode"), error.toString()));
			out.flush();
			out.close();
		}
		
		try {
			
			String vbillcode = p_data.getString("vbillcode");//ȡ
			PMOAggVO pmoAggVO = getPmoVO(vbillcode);
			out.print(formatRSJsonData(TURE, p_data.getString("vbillcode"), "ɹ"));
			
		} catch (MetaDataException e) {
			out.print(formatRSJsonData(FALSE, p_data.getString("vbillcode"), e.getMessage()==null?e.toString():e.getMessage().toString()));
			out.flush();
			out.close();
		}
		
	}
	
	/*
	 * ǿж
	 */
	private boolean checkJson(JSONObject p_data) {
		
		boolean check = true;
		StringBuffer mags = new StringBuffer();
		
		String vbillcode = "vbillcode";//
 
		String[] HeadKey = {vbillcode};
		
		for (String as : HeadKey) {

			if (p_data.getString(as).isEmpty()) {
				mags.append("'" + as + "' ");
				check = false;
			}
		}
		
		if (!check) {
			error.append("ֶβΪգ"+mags);
		}
		return check;
	}
	
	/*
	 * ȡVO
	 */
	private PMOAggVO getPmoVO(String vbillcode) throws MetaDataException {
		
		PMOAggVO pmoAggVO = (PMOAggVO) qryService.queryBillOfVOByCond(PMOAggVO.class, vbillcode,true,false);
		
		if (pmoAggVO == null) {
			error.append("ݵݺ'"+vbillcode+"'δҵ飡");
			return null;
		}
		
		return pmoAggVO;
		
	}

}
